aboutsummaryrefslogtreecommitdiffstats
path: root/resources/libraries/bash/function/device.sh
diff options
context:
space:
mode:
Diffstat (limited to 'resources/libraries/bash/function/device.sh')
-rw-r--r--resources/libraries/bash/function/device.sh185
1 files changed, 137 insertions, 48 deletions
diff --git a/resources/libraries/bash/function/device.sh b/resources/libraries/bash/function/device.sh
index 868fdb1342..8bfb2e458c 100644
--- a/resources/libraries/bash/function/device.sh
+++ b/resources/libraries/bash/function/device.sh
@@ -78,7 +78,7 @@ function bind_interfaces_to_containers () {
sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
}
- docker exec "${DCR_UUIDS[dut1]}" ${cmd} || {
+ docker exec "${DCR_UUIDS[dut1]}" ${cmd} || {
die "Linking PCI address in container failed!"
}
done
@@ -245,16 +245,20 @@ function get_available_interfaces () {
# - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
# - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
# - DUT1_DRIVERS - List of interface drivers to DUT1 container.
+ # - DUT1_VLANS - List of interface vlans to TG container.
+ # - DUT1_MODEL - List of interface models to TG container.
# - TG_NETDEVS - List of network devices allocated to TG container.
# - TG_PCIDEVS - List of PCI addresses allocated to TG container.
# - TG_NETMACS - List of MAC addresses allocated to TG container.
# - TG_DRIVERS - List of interface drivers to TG container.
+ # - TG_VLANS - List of interface vlans to TG container.
+ # - TG_MODEL - List of interface models to TG container.
set -exuo pipefail
- # Following code is specifing VFs ID based on nodeness and flavor.
+ # Following code is specifying VFs ID based on nodeness and flavor.
# As there is great variability in hardware configuration outside LF,
- # from bootstrap architecure point of view these are considered as flavors.
+ # from bootstrap architecture point of view these are considered as flavors.
# Anyone can override flavor for its own machine and add condition here.
# See http://pci-ids.ucw.cz/v2.2/pci.ids for more info.
case_text="${1}_${2}"
@@ -262,9 +266,10 @@ function get_available_interfaces () {
"1n_skx")
# Add Intel Corporation XL710/X710 Virtual Function to the
# whitelist.
- pci_id="0x154c"
- tg_netdev=(ens1 enp24)
- dut1_netdev=(ens5 enp59)
+ pci_id="0x154c\|0x1889"
+ tg_netdev=(ens1 enp134)
+ dut1_netdev=(ens5 enp175)
+ ports_per_nic=2
;;
"1n_tx2")
# Add Intel Corporation XL710/X710 Virtual Function to the
@@ -272,6 +277,7 @@ function get_available_interfaces () {
pci_id="0x154c"
tg_netdev=(enp5)
dut1_netdev=(enp145)
+ ports_per_nic=2
;;
"1n_vbox")
# Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
@@ -279,43 +285,47 @@ function get_available_interfaces () {
pci_id="0x100f"
tg_netdev=(enp0s8 enp0s9)
dut1_netdev=(enp0s16 enp0s17)
+ ports_per_nic=1
;;
*)
die "Unknown specification: ${case_text}!"
esac
- device_count=2
-
# TG side of connections.
TG_NETDEVS=()
TG_PCIDEVS=()
TG_NETMACS=()
TG_DRIVERS=()
TG_VLANS=()
+ TG_MODEL=()
# DUT1 side of connections.
DUT1_NETDEVS=()
DUT1_PCIDEVS=()
DUT1_NETMACS=()
DUT1_DRIVERS=()
DUT1_VLANS=()
+ DUT1_MODEL=()
# Find the first ${device_count} number of available TG Linux network
# VF device names. Only allowed VF PCI IDs are filtered.
for netdev in ${tg_netdev[@]}
do
+ ports=0
for netdev_path in $(grep -l "${pci_id}" \
/sys/class/net/${netdev}*/device/device \
2> /dev/null)
do
- if [[ ${#TG_NETDEVS[@]} -lt ${device_count} ]]; then
+ if [[ ${ports} -lt ${ports_per_nic} ]]; then
tg_netdev_name=$(dirname ${netdev_path})
tg_netdev_name=$(dirname ${tg_netdev_name})
TG_NETDEVS+=($(basename ${tg_netdev_name}))
+ ((ports++))
else
break
fi
done
- if [[ ${#TG_NETDEVS[@]} -eq ${device_count} ]]; then
+ ports_per_device=$((${ports_per_nic}*${#tg_netdev[@]}))
+ if [[ ${#TG_NETDEVS[@]} -eq ${ports_per_device} ]]; then
break
fi
done
@@ -339,29 +349,30 @@ function get_available_interfaces () {
get_mac_addr
get_krn_driver
get_vlan_filter
+ get_csit_model
TG_PCIDEVS+=(${PCI_ADDR})
TG_NETMACS+=(${MAC_ADDR})
TG_DRIVERS+=(${KRN_DRIVER})
TG_VLANS+=(${VLAN_ID})
+ TG_MODELS+=(${MODEL})
done
for NETDEV in "${DUT1_NETDEVS[@]}"; do
get_pci_addr
get_mac_addr
get_krn_driver
get_vlan_filter
+ get_csit_model
DUT1_PCIDEVS+=(${PCI_ADDR})
DUT1_NETMACS+=(${MAC_ADDR})
DUT1_DRIVERS+=(${KRN_DRIVER})
DUT1_VLANS+=(${VLAN_ID})
+ DUT1_MODELS+=(${MODEL})
done
# We need at least two interfaces for TG/DUT1 for building topology.
- if [ "${#TG_NETDEVS[@]}" -ne 2 ] || [ "${#DUT1_NETDEVS[@]}" -ne 2 ]; then
+ if [ "${#TG_NETDEVS[@]}" -lt 2 ] || [ "${#DUT1_NETDEVS[@]}" -lt 2 ]; then
die "Not enough linux network interfaces found!"
fi
- if [ "${#TG_PCIDEVS[@]}" -ne 2 ] || [ "${#DUT1_PCIDEVS[@]}" -ne 2 ]; then
- die "Not enough pci interfaces found!"
- fi
}
@@ -402,6 +413,35 @@ function get_mac_addr () {
}
+function get_csit_model () {
+
+ # Get CSIT model name from linux network device name.
+ #
+ # Variables read:
+ # - NETDEV - Linux network device name.
+ # Variables set:
+ # - MODEL - CSIT model name of network device.
+
+ set -exuo pipefail
+
+ if [ -d /sys/class/net/${NETDEV}/device ]; then
+ ID="$(</sys/class/net/${NETDEV}/device/device)" || {
+ die "Failed to get device id of linux network interface!"
+ }
+ case "${ID}" in
+ "0x1592"|"0x1889")
+ MODEL="Intel-E810CQ"
+ ;;
+ "0x1572"|"0x154c")
+ MODEL="Intel-X710"
+ ;;
+ "*")
+ MODEL="virtual"
+ esac
+ fi
+}
+
+
function get_pci_addr () {
# Get PCI address in <domain>:<bus:<device>.<func> format from linux network
@@ -461,6 +501,55 @@ function installed () {
}
+function parse_env_variables () {
+
+ # Parse environment variables.
+ #
+ # Variables read, set or exported: Multiple,
+ # see the code for the current list.
+
+ set -exuo pipefail
+
+ IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
+ IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
+ IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
+ IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
+ IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
+ IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
+ IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
+ IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
+
+ for port in $(seq "${#TG_NETMACS[*]}"); do
+ CSIT_TG_INTERFACES+=$(cat << EOF
+ port$((port-1)):
+ mac_address: "${TG_NETMACS[$((port-1))]}"
+ pci_address: "${TG_PCIDEVS[$((port-1))]}"
+ link: "link$((port-1))"
+ model: "${TG_MODELS[$((port-1))]}"
+ driver: "${TG_DRIVERS[$((port-1))]}"
+ vlan: ${TG_VLANS[$((port-1))]}
+EOF
+ )
+ CSIT_TG_INTERFACES+=$'\n'
+ done
+ for port in $(seq "${#DUT1_NETMACS[*]}"); do
+ CSIT_DUT1_INTERFACES+=$(cat << EOF
+ port$((port-1)):
+ mac_address: "${DUT1_NETMACS[$((port-1))]}"
+ pci_address: "${DUT1_PCIDEVS[$((port-1))]}"
+ link: "link$((port-1))"
+ model: "${DUT1_MODELS[$((port-1))]}"
+ driver: "${DUT1_DRIVERS[$((port-1))]}"
+ vlan: ${DUT1_VLANS[$((port-1))]}
+EOF
+ )
+ CSIT_DUT1_INTERFACES+=$'\n'
+ done
+}
+
+
function print_env_variables () {
# Get environment variables prefixed by CSIT_.
@@ -479,7 +568,6 @@ function read_env_variables () {
# - ${@} - Variables passed as an argument.
# Variables read, set or exported: Multiple,
# see the code for the current list.
- # TODO: Do we need to list them and their meanings?
set -exuo pipefail
@@ -489,18 +577,17 @@ function read_env_variables () {
declare -gA DCR_UUIDS
DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
- TG_PCIDEVS=("${CSIT_TG_INTERFACES_PORT1_PCI}")
- TG_DRIVERS=("${CSIT_TG_INTERFACES_PORT1_DRV}")
- TG_VLANS+=("${CSIT_TG_INTERFACES_PORT1_VLAN}")
- TG_PCIDEVS+=("${CSIT_TG_INTERFACES_PORT2_PCI}")
- TG_DRIVERS+=("${CSIT_TG_INTERFACES_PORT2_DRV}")
- TG_VLANS+=("${CSIT_TG_INTERFACES_PORT2_VLAN}")
- DUT1_PCIDEVS=("${CSIT_DUT1_INTERFACES_PORT1_PCI}")
- DUT1_DRIVERS=("${CSIT_DUT1_INTERFACES_PORT1_DRV}")
- DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT1_VLAN}")
- DUT1_PCIDEVS+=("${CSIT_DUT1_INTERFACES_PORT2_PCI}")
- DUT1_DRIVERS+=("${CSIT_DUT1_INTERFACES_PORT2_DRV}")
- DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT2_VLAN}")
+
+ IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
+ IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
+ IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
+ IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
+ IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
+ IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
+ IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
+ IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
}
@@ -511,13 +598,18 @@ function set_env_variables () {
# Variables read:
# - DCR_UUIDS - Docker Container UUIDs.
# - DCR_PORTS - Docker Container's SSH ports.
- # - DUT1_NETMACS - List of network devices MAC addresses of DUT1 container.
- # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
+ # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
+ # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
+ # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
# - DUT1_DRIVERS - List of interface drivers to DUT1 container.
- # - TG_NETMACS - List of network devices MAC addresses of TG container.
- # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
+ # - DUT1_VLANS - List of interface vlans to TG container.
+ # - DUT1_MODEL - List of interface models to TG container.
+ # - TG_NETDEVS - List of network devices allocated to TG container.
+ # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
+ # - TG_NETMACS - List of MAC addresses allocated to TG container.
# - TG_DRIVERS - List of interface drivers to TG container.
- # Variables set: TODO.
+ # - TG_VLANS - List of interface vlans to TG container.
+ # - TG_MODEL - List of interface models to TG container.
set -exuo pipefail
@@ -538,23 +630,20 @@ function set_env_variables () {
CSIT_DUT1_ARCH="$(uname -i)" || {
die "Reading machine architecture failed!"
}
- CSIT_TG_INTERFACES_PORT1_MAC="${TG_NETMACS[0]}"
- CSIT_TG_INTERFACES_PORT1_PCI="${TG_PCIDEVS[0]}"
- CSIT_TG_INTERFACES_PORT1_DRV="${TG_DRIVERS[0]}"
- CSIT_TG_INTERFACES_PORT1_VLAN="${TG_VLANS[0]}"
- CSIT_TG_INTERFACES_PORT2_MAC="${TG_NETMACS[1]}"
- CSIT_TG_INTERFACES_PORT2_PCI="${TG_PCIDEVS[1]}"
- CSIT_TG_INTERFACES_PORT2_DRV="${TG_DRIVERS[1]}"
- CSIT_TG_INTERFACES_PORT2_VLAN="${TG_VLANS[1]}"
- CSIT_DUT1_INTERFACES_PORT1_MAC="${DUT1_NETMACS[0]}"
- CSIT_DUT1_INTERFACES_PORT1_PCI="${DUT1_PCIDEVS[0]}"
- CSIT_DUT1_INTERFACES_PORT1_DRV="${DUT1_DRIVERS[0]}"
- CSIT_DUT1_INTERFACES_PORT1_VLAN="${DUT1_VLANS[0]}"
- CSIT_DUT1_INTERFACES_PORT2_MAC="${DUT1_NETMACS[1]}"
- CSIT_DUT1_INTERFACES_PORT2_PCI="${DUT1_PCIDEVS[1]}"
- CSIT_DUT1_INTERFACES_PORT2_DRV="${DUT1_DRIVERS[1]}"
- CSIT_DUT1_INTERFACES_PORT2_VLAN="${DUT1_VLANS[1]}"
+ OIFS="$IFS" IFS=@
+ set -a
+ CSIT_TG_INTERFACES_PORT_MAC="${TG_NETMACS[*]}"
+ CSIT_TG_INTERFACES_PORT_PCI="${TG_PCIDEVS[*]}"
+ CSIT_TG_INTERFACES_PORT_DRV="${TG_DRIVERS[*]}"
+ CSIT_TG_INTERFACES_PORT_VLAN="${TG_VLANS[*]}"
+ CSIT_TG_INTERFACES_PORT_MODEL="${TG_MODELS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_MAC="${DUT1_NETMACS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_PCI="${DUT1_PCIDEVS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_DRV="${DUT1_DRIVERS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_VLAN="${DUT1_VLANS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_MODEL="${DUT1_MODELS[*]}"
set +a
+ IFS="$OIFS"
}